;Allgemein----------------------------------------
Global xf = 600
Global yf = 800

Global mx
Global my
Global mz
Global mxs
Global mys
Global mzs
Global mht1
Global mht2
AppTitle("klackKlackKLACK! - BCC #75")

Graphics xf,yf,32,2
SetBuffer BackBuffer()
ClsColor 127,127,127
MoveMouse xf/2,yf/2


;Allgemein----------------------------------------
SeedRnd(MilliSecs())

Global score,pay,launch,ka,k2on,kb,neuball
neuball = 6
kb = 50
Global brems# = 0.96
Global schluckspeed# = 0.4
Global schwerkraft# = 0.02
Global pf$ = ".\data\"
SetFont LoadFont("Arial",48,1)


Dim p#(100,1)
Dim k#(99,4)
Dim win(9,1)



;Bilder-------------------------------------------
Global ball = LoadImage(pf+"ball.png")
MaskImage ball,255,0,255
MidHandle ball

Global nagel = LoadImage(pf+"nagel.png")
MaskImage nagel,255,0,255
MidHandle nagel

Global hole = LoadImage(pf+"hole.png")
MaskImage hole,255,0,255
MidHandle hole

Global background = LoadImage(pf+"background.png")


;Sound--------------------------------------------
Global maxsoundklack = 6
Dim soundklack(maxsoundklack+3)
For i=0 To maxsoundklack+3
	soundklack(i) = LoadSound(pf+"klack"+(i+1)+".wav")
Next



;Start--------------------------------------------
Laden()
p(0,0) = 135
p(0,1) = 145
For i=0 To 49
	k(i,0) = (xf/4-35)+Rnd(-10,10)
	k(i,1) = (yf/2+285)+Rnd(-10,10)
	k(i,4) = 2
Next

;Hauptschleife------------------------------------
fps = CreateTimer(60)
While Not KeyHit(1)
	WaitTimer(fps)
	Cls
	mx = MouseX()
	my = MouseY()
	mht1 = MouseHit(1)
	mht2 = MouseHit(2)
	Launcher()
	k2on = 1
	For i=0 To 1
		Physik()
		Rahmen()
		Kollision2()
		Kollision()
		Schlucker()
		k2on = 0
	Next
	Bonus()
	Malen()
	Color 255,255,255
	Text 5,5,"Punkte:"
	Text 5,45,score
	Flip 0
Wend
End



;Funktionen---------------------------------------
Function Bonus()
	For i=0 To 99
		If k(i,4) = 1 Then
			played = 0
			For j=0 To 9
				xvek# = k(i,0)-win(j,0)
				yvek# = k(i,1)-win(j,1)
				l# = entf( xvek,yvek )
				If l < 7 Then
					k(i,4) = 0
					score = score+neuball
					pay = pay+neuball
					ka = ka-1
					If played = 0 Then
						channel = PlaySound(soundklack(Rand(8,9)))
						ChannelVolume channel,0.4
						played = 1
					EndIf
				EndIf
			Next
		EndIf
	Next
	b = 0
	If kb+ka < 100-neuball And pay >= neuball Then
		For a=0 To 99
			If k(a,4) = 0 Then
				k(a,0) = (xf/4-35)+Rnd(-10,10)
				k(a,1) = (yf/2+285)+Rnd(-10,10)-40
				k(a,4) = 2
				b = b+1
				If b = neuball Then a = 100
			EndIf
		Next
		kb = kb+neuball
		pay = pay-neuball
	EndIf
End Function


Function Laden()
	datei = ReadFile(pf+"pin.dat")
	For i=1 To 100
		p(i,0) = ReadFloat(datei)
		p(i,1) = ReadFloat(datei)
	Next
	For i=0 To 9
		win(i,0) = ReadFloat(datei)
		win(i,1) = ReadFloat(datei)
	Next
	CloseFile(datei)
End Function


Function Launcher()
	If mht1 Then launch = MilliSecs()
	If MouseDown(1) = 0 And launch <> 0 Then
		imerk =-1
		d# = 99999
		For i=0 To 99
			If k(i,4) = 2 Then
				xvek# = k(i,0)-(xf/4-35)
				yvek# = k(i,1)-(yf/2+355)
				l# = entf( xvek,yvek )
				If l < d Then
					d = l
					imerk = i
				EndIf
			EndIf
		Next
		If kb > 0 Then
			i = imerk
			If i <>-1 Then
				k(i,4) = 1
				k(i,0) = xf/2+195*Sin(45)
				k(i,1) = yf/2-150-195*Cos(45)
				k(i,3) =-(MilliSecs()-launch)/100.0
				If k(i,3) <-5 Then k(i,3) =-5
				k(i,2) = k(i,3)
				channel = PlaySound(soundklack(7))
				ChannelVolume channel,-k(i,3)/5.0+0.2
			EndIf
			kb = kb-1
			ka = ka+1
		EndIf
		launch = 0
	EndIf
End Function


Function Schlucker()
	For i=0 To 99
		If k(i,4) = 1 Then
			xvek# = k(i,0)-(xf/2)
			yvek# = k(i,1)-(yf/2+245)
			l# = entf( xvek,yvek )
			If l < 10 Then
				If Abs(k(i,2)) < schluckspeed And Abs(k(i,3)) < schluckspeed Then
					k(i,4) = 0
					ka = ka-1
				EndIf
			EndIf
		EndIf
	Next
End Function


Function Rahmen()
	For i=0 To 99
		If k(i,4) = 1 Then
			If k(i,0) < 105 Then
				k(i,2) =-k(i,2)
				k(i,0) = 105
				k(i,2) = k(i,2)*brems
				k(i,3) = k(i,3)*brems
			EndIf
			If k(i,0) > xf-105 Then
				k(i,2) =-k(i,2)
				k(i,0) = xf-105
				k(i,2) = k(i,2)*brems
				k(i,3) = k(i,3)*brems
			EndIf
			If k(i,1) >= (yf/2+50) Then
				xvek# = k(i,0)-(xf/2)
				yvek# = k(i,1)-(yf/2+50)
				l# = entf( xvek,yvek )
				If l > 195 Then
					xv# = xvek/l
					yv# = yvek/l
					d# = xv*k(i,2)+yv*k(i,3)
					k(i,2) = (k(i,2)-2*d*xv)*brems
					k(i,3) = (k(i,3)-2*d*yv)*brems
					k(i,0) = k(i,0)+xv*(195-l)
					k(i,1) = k(i,1)+yv*(195-l)
				EndIf
			EndIf
			If k(i,1) <= (yf/2-150) Then
				xvek# = k(i,0)-(xf/2)
				yvek# = k(i,1)-(yf/2-150)
				l# = entf( xvek,yvek )
				If l > 195 Then
					xv# = xvek/l
					yv# = yvek/l
					d# = xv*k(i,2)+yv*k(i,3)
					k(i,2) = (k(i,2)-2*d*xv)*brems
					k(i,3) = (k(i,3)-2*d*yv)*brems
					k(i,0) = k(i,0)+xv*(195-l)
					k(i,1) = k(i,1)+yv*(195-l)
				EndIf
			EndIf
		EndIf
		If k(i,4) = 2 Then
			xvek# = k(i,0)-(xf/4-35)
			yvek# = k(i,1)-(yf/2+285)
			l# = entf( xvek,yvek )
			If l > 70 Then
				xv# = xvek/l
				yv# = yvek/l
				d# = xv*k(i,2)+yv*k(i,3)
				k(i,2) = (k(i,2)-2*d*xv)*brems
				k(i,3) = (k(i,3)-2*d*yv)*brems
				k(i,0) = k(i,0)+xv*(70-l)
				k(i,1) = k(i,1)+yv*(70-l)
			EndIf
		EndIf
	Next
End Function


Function Kollision()
	For i=0 To 99
		If k(i,4) = 1 Then
			For j=0 To 100
				xvek# = k(i,0)-p(j,0)
				yvek# = k(i,1)-p(j,1)
				l# = entf( xvek,yvek )
				If l# < 8 And l <> 0 Then
					xv# = xvek/l
					yv# = yvek/l
					d# = xv*k(i,2)+yv*k(i,3)
					k(i,2) = (k(i,2)-2*d*xv)*brems
					k(i,3) = (k(i,3)-2*d*yv)*brems
					k(i,0) = k(i,0)+xv*(8-l)
					k(i,1) = k(i,1)+yv*(8-l)
					channel = PlaySound(soundklack(Rand(0,maxsoundklack)))
					l = entf(k(i,2),k(i,3))/5.0
					If l > 1 Then l = 1
					If l < 0.1 Then l = 0
					ChannelVolume channel,0.5*l
				EndIf
			Next
		EndIf
	Next
End Function


Function Kollision2()
	For i=0 To 99
		If k(i,4) = 1 Or (k(i,4) = 2 And k2on) Then
			For j=i+1 To 99
				If k(j,4) = k(i,4) Then
					xvek# = k(i,0)-k(j,0)
					yvek# = k(i,1)-k(j,1)
					l# = entf( xvek,yvek )
					If l# < 10 And l <> 0 Then
						xv# = xvek/l
						yv# = yvek/l
						a1# = xv*k(i,2)+yv*k(i,3)
						a2# = xv*k(j,2)+yv*k(j,3)
						k(i,2) = (k(i,2)-a1*xv+a2*xv)*brems*brems
						k(i,3) = (k(i,3)-a1*yv+a2*yv)*brems*brems
						k(j,2) = (k(j,2)-a2*xv+a1*xv)*brems*brems
						k(j,3) = (k(j,3)-a2*yv+a1*yv)*brems*brems
						k(i,0) = k(i,0)+xv*(10-l)/2.0
						k(i,1) = k(i,1)+yv*(10-l)/2.0
						k(j,0) = k(j,0)-xv*(10-l)/2.0
						k(j,1) = k(j,1)-yv*(10-l)/2.0
						channel = PlaySound(soundklack(Rand(0,maxsoundklack)))
						l = (Abs(a1)+Abs(a2))/5.0
						If l > 1 Then l = 1
						If l < 0.1 Then l = 0
						ChannelVolume channel,0.5*l
					EndIf
				EndIf
			Next
		EndIf
	Next
End Function


Function Physik()
	For i=0 To 99
		If k(i,4) <> 0 Then
			k(i,3) = k(i,3)+schwerkraft
			k(i,0) = k(i,0)+k(i,2)
			k(i,1) = k(i,1)+k(i,3)
			If k(i,1) > yf+10 Then
				k(i,3) = 0
				k(i,2) = 0
				k(i,0) = xf/2
				k(i,1) = 60
			EndIf
		EndIf
	Next
End Function


Function Malen()
	DrawBlock background,0,0
	DrawImage hole,xf/2+195*Sin(45)-1,yf/2-150-195*Cos(45)+1
	For i=0 To 9
		DrawImage hole,win(i,0),win(i,1)
	Next
	For i=0 To 100
		DrawImage nagel,p(i,0),p(i,1)
	Next
	For i=0 To 99
		If k(i,4) <> 0 Then
			DrawImage ball,k(i,0),k(i,1)
		EndIf
	Next
End Function


Function entf#(x#,y#)
	Return Sqr(x*x+y*y)
End Function



